# View Program History
source: https://developer.mastercard.com/donations/documentation/use-cases/manage-donation-trns/view-prg-hist/index.md

## Overview {#overview}

The **Program Transaction History** endpoint retrieves a list of donation transactions by `programId` in a given period. To fetch the list of donations received under a program, provide the unique `programId` as the endpoint path parameter.

You can also limit the program donation history to view the transactions made for either or all of these parameters for a specific:

* Payment card
* Charity
* Donor ID
* Donation type   

If you provide only the donation period in the request body, Mastercard Donate fetches all the donations received under a program for all the registered charities and donation types for the given period. A micro donation setup shows up in donation history only until the end of the month when the transaction happens.

## Sequence Diagram {#sequence-diagram}

The following outlines the sequence of events:

Diagram programtransactionhistory

## Execution Steps {#execution-steps}

The following details the steps in the above sequence diagram:

1. The partner requests to view the donation transactions for a particular program and date range.
2. The partner user interface forwards the request to the partner server and provides the `programId` in the request.
3. The partner server sends the `programID` in the POST request to Mastercard Donate to retrieve the list of donation transactions for the provided program.
4. Mastercard Donate returns a list of transactions including the `charityId`, `donationType`, `fromDate` and `toDate`.
5. The partner server sends the data to the partner user interface.
6. The partner user interface displays the program donation history.

## Endpoint {#endpoint}


API Reference: `POST /programs/{program_id}/transactions`


API Reference: `GET /programs/{program_id}/transactions`

## Endpoint Parameter {#endpoint-parameter}

For more details on the endpoint parameters, refer to the [Parameters to Retrieve Program Transaction History](https://developer.mastercard.com/donations/documentation/parameters/track-donations-param/prog-trans-hist/index.md) section.

## Sample Request and Response {#sample-request-and-response}

For more details on the sample request and response, refer to the [Retrieve donations received for a charity program](https://developer.mastercard.com/donations/tutorial/donation-api-details/historyapi/index.md) tutorial.
